const _O = Object;

const _dispersed_eng                                 = require("nv-pg-dispersed-eng");
const _basic                                         = require("nv-query-paper-basic");
const {DATA_EN2CH,DATA_CH2EN}                        = _basic.def;
const _idlock                                        = require("nv-facutil-idlock"); 
const nofix_eng                                      = require("nv-pg-nofix-eng");
const {OASGN,is_ary,kvlist2d,is_str,instof}          = require("nv-facutil-basic");
const {Manual}                                       = require("nv-facutil-clock");

const  _get_file_ids = (r)=> {
    let ids = []
    ids = ids.filter(e=>e[2]!=="");
    return(ids)
}

const  _file_commit  = async(oss,fids) =>{
    return([true,'no_check'])
}

const _creat_expt_ch_dict = (d)=> {
      let nd = {}
      for(let k in DATA_CH2EN) {
              let en = DATA_CH2EN[k]
              let v  = d[en];
              if(instof(v,_O)) {
                      
              } else {
                  v = String(v)
              }
              nd[k] = v
              
      }
      let update_at  = new Manual(Number(d.update_at))
      let tmd        = update_at.sdict();
      nd['操作时间'] =  tmd.y + tmd.m + tmd.d;
      return(nd) 
}


const _creat_file_name = (d,k,i='')=> {
    let rslt= (d.操作时间+'_'+ d.openid+ '_'+d.姓名+'_'+d.电话+ '_'+k+i+'.'+d[k].type.split("/")[1]);
    delete d[k].type
    return(rslt)
}



const _fill_fary_name = (d,k)=> {
    for(let i=0;i<d[k].length;i++) {
        d[k][i].name = d.操作时间+'_'+ d.openid+ '_' +d.姓名+'_'+d.电话+ '_'+k+i+'.'+d[k][i].type.split("/")[1] 
        delete d[k][i].type
    }
}


const _grpby = (rows,k="sheet_id",sort_func=(a,b)=>Number(a.seq-b.seq)) => {
        let d = {}
        for(let row of rows) {
            if(d[row[k]]) {
                 d[row[k]].push(row)
            } else {
                 d[row[k]] =[row]
            }
        }
        let rslt = [];
        for(let k in d) {
             d[k].sort(sort_func);
             let loan_start_at = d[k][0].loan_start_at;
             rslt.push([loan_start_at,k,d[k]])
        }
        rslt.sort((a,b)=>Number(a[0]-b[0]));
        let nd = {}
        for(let e of rslt) {
            let expt = e[2];
            for(let i=0;i<expt.length;i++) {
                expt[i] = _creat_expt_ch_dict(expt[i]);
            }
            nd[e[1]] = expt
        }
        return(nd)
}




class DataBase extends nofix_eng.DB {
    tbl = 'query'
    constructor(dbname,tbl,cfgdb,retry_redis,wx,oss) {
        super(dbname);
        this.tbl                = tbl??this.tbl;
        this.lock               = _idlock.creat();
        ////-------------------------------------------------------------------
        this.cfgdb              = cfgdb;
        this.retry_redis        = retry_redis;
        this.wx                 = wx;
        this.oss                = oss;
        ////------------------------------------------------------------------
    }
    //兼容舊代碼，，此處無用
    async init_qp() {
        //初始化操作在query-srv上已經全部完成
    }
    //创建记录
    async is_fst_time(openid) {
        let cnt = await this.count({cond:`openid==="${openid}"`});
        return(cnt<=0) 
    }
    async get_sheet_id_with_openid(openid) {
        let rows = await this.select({cond:`openid==="${openid}"`});
        return(rows[0]?.sheet_id) 
    }
    async get_openid_with_sheet_id(sheet_id) {
        let rows = await this.select({cond:`sheet_id==="${sheet_id}"`});
        return(rows[0]?.openid)
    }
    _cudata_tmpl_for_creat() {
        return({
            oper : '來自 validate userid', 
            appid: 'query-srv 上的屬性',                  
            paper_name:'query-srv 上的屬性',   
            ////---
            openid:'來自query-srv http 收到的前端信息',
            cuname:'來自query-srv http 收到的前端信息',
            corp:'來自query-srv http 收到的前端信息',
            phone:'來自query-srv http 收到的前端信息',
        })
    }
    //初次浏览
    async creat(cudata) {
        let [cond,data] = _basic.cls.creat(cudata);
        if(cond) {
            let is_fst = await this.is_fst_time(cudata.openid);
            if(is_fst) {
                let paramd         = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl         = this.tbl;
                paramd.data        = data.dict();                   //會自動填充 {sheet_id seq:0}
                paramd.data.action = _basic.def.ACT_EN2CH.audit;    /*_basic.def.ACT_EN2CH.creat 自動audit*/;
                paramd.data.all_files_ok = true;
                ////
                let r              = await this.insert_one(paramd);
                r = r[0];
                ////---複製一條相同記錄但是序號+1的
                paramd.data.seq   = paramd.data.seq+1n;
                await this.insert_one(paramd);
                ////
                return([true,r])
            } else {
                return([false,"信息已存在,请直接调用answer接口"])
            }
        } else {
            return([false,data])
        }
    }
    //
    async _get_entries(sheet_id) {
        let paramd          = nofix_eng.DB.SELECT_PARAM.select_with_match();
        paramd.tbl          = this.tbl;
        paramd.cond         = `sheet_id==='${sheet_id}'`;
        let r               = await this.select_with_match(paramd);
        r.sort((a,b)=>Number(a.seq-b.seq));
        return(r)        
    }
    //
    async _get_fst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        return(es[0])
    }
    async _get_lst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        return(es[es.length-1])
    }    
    async _get_fst_lst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        if(es.length>1) {
           return([es[0],es[es.length-1]])
        } else {
           let e0 = es[0];
           let e1 = {}
           Object.assign(e1,e0)     
           return([e0,e1])
        }
    }
    //获取明细
    async get_details(sheet_id) {
         let es = await this._get_entries(sheet_id);
         return(es.slice(1))
    }
    //更新备注
    async update_extra(cudata) {
         let {sheet_id,oper,extra} = cudata;
         //let sheet_id = await this.get_sheet_id_with_openid(openid);
         await this.lock.acquire(sheet_id);
         let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
         let extra_str = JSON.stringify(extra);
         extra_str     = extra_str.replace(/'/g,"''");
         let sql = `UPDATE ${this.tbl} SET extra='${extra_str}' WHERE c0='${sheet_id}' AND c1=0  RETURNING *;`;
         let r = await this.exec_raw_sql(sql);
         this.lock.release(sheet_id);
         return([true,r])
    }  
    //回答问题
    _cudata_tmpl_for_answer(cudata) {
         let d = {
             oper:'',   //query-srv 傳入
             /////
             openid:'', //前端傳入
             ////query-srv 從answer 的 info解出
             sex:'性别',    
             year_old:"年龄",
             education:"文化程度",
             political:"政治面貌",
             professtion:'职业',
             ////-------------------
             answer:{}, //前端提交
             exam:[],   //query-srv 根據paper 和answer計算
             ////---------------後端query-srv計算
             can_draw_lottery:false,
         }
         Object.seal(d);
         Object.assign(d,cudata);//query-srv 過濾過數據 cudata是可靠的 
         return(d)
    }
    //用戶提交答卷后
    //query-srv 先插入數據庫
    async answer(cudata) {
        let D      = this._cudata_tmpl_for_answer(cudata);
        let openid = D.openid;
        let sheet_id =await this.get_sheet_id_with_openid(openid);
        if(sheet_id === undefined) {
            return([false,"信息不存在,请先调用creat接口"])
        } else if(!D.answer instanceof Object) {
            return([false,"answer必须是obj"])
        } else if(!D.can_draw_lottery) {
            return([false,"不能漏答"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            lst.seq       = lst.seq+1n;
            lst.action    = _basic.def.ACT_EN2CH.answer;
            /*计算是否能够抽奖*/
            Object.assign(lst,D); //包含oper
            /*计算是否能够抽奖*/
            let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
            paramd.tbl  = this.tbl;
            paramd.data = lst;
            let r       = await this.insert_one(paramd);
            r = r[0];
            //fst.seq              = fst.seq;    
            fst.action             = _basic.def.ACT_EN2CH.answer;
            Object.assign(fst,D);  //更新除seq外的數據與最新一條一致 
            paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
            paramd.tbl             = this.tbl;
            paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
            paramd.data            = fst;
            let r0 = await this.update_with_match(paramd);
            r0 = r0[0];
            this.lock.release(sheet_id);
            return([true,r,r0])
        }
    }
    //是否能抽奖
    async is_can_draw_lottery(sheet_id) {
        let r = await this.select({cond:`sheet_id==="${sheet_id}" && seq===0 && can_draw_lottery===true`});
        return(r.length>0)
    }
    //是否已抽奖
    async is_drawed(sheet_id) {
        let r = await this.select({cond:`sheet_id==="${sheet_id}" && seq===0 && is_drawed===true`});
        return(r.length>0)
    }
    //用户抽奖 query-srv  /*re_openid,clientversion, client_ip由后端route-srv填充*/ 
    _cudata_tmpl_for_draw_lottery(cudata) {
        let d = {
            oper:'',       //query-srv 填充
            ////
            openid:'',
            ////
            draw_level:'',
            draw_cash:0,
            ////
        }
        Object.seal(d);
        Object.assign(d,cudata);//query-srv 過濾過數據 cudata是可靠的
        return(d)
    }
    //query-srv 發送send-hb后調用
    //   如果can_draw_lottery
    //       query-srv 調用wx 接口抽獎
    //          根據結果決定是否retry
    //              如果需要retry
    //          然後啓用查詢任務:如果狀態為received 終止任務
    //   否則直接返回前端 [false,reason]
    async draw_lottery(cudata) {
        let D = this._cudata_tmpl_for_draw_lottery(cudata);
        let openid = D.openid;                                            
        let sheet_id =await this.get_sheet_id_with_openid(openid);
        if(sheet_id === undefined) {
            return([false,"信息不存在,请先调用creat接口"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            lst.seq       = lst.seq+1n;
            lst.action    = _basic.def.ACT_EN2CH.draw_lottery;
            if(fst.is_drawed) {
                this.lock.release(sheet_id);
                return([false,"只能抽奖一次"])
            } else if(!fst.can_draw_lottery) {
                this.lock.release(sheet_id);
                return([false,"最近一次回答必须满足抽奖条件"])
            } else {
                Object.assign(lst,D); //oper draw_level 
                lst.is_drawed   = true;  //這隻狀態
                //----------------
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst;
                let r       = await this.insert_one(paramd);
                r = r[0];
                fst.action             = _basic.def.ACT_EN2CH.draw_lottery;
                Object.assign(fst,D); //oper draw_level 
                fst.is_drawed          = true;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                //----------------------------------------------------------------------
                this.lock.release(sheet_id);
                return([true,r0])
            }
        }
    }
    //更新狀態 只能被後端調用
    _cudata_tmpl_for_update(cudata) {
        let d = {
            openid:'',
            oper:'',
            action:'',
            is_drawed:undefined,
            draw_level:undefined,
            draw_cash:undefined,
            give_hb_req:undefined,
            give_hb_res:undefined,
            is_hb_taked:undefined,
            take_hb_req:undefined,
            take_hb_res:undefined,
        }
        //Object.seal(d); this cant seal
        Object.assign(d,cudata);
        for(let k in d) {
           if(d[k]===undefined) {
               delete d[k];
           } else {}
        }
        return(d)
    }
    async _update(cudata) {
        let D = this._cudata_tmpl_for_update(cudata);
        let openid = D.openid;
        let sheet_id =await this.get_sheet_id_with_openid(openid);
        if(sheet_id === undefined) {
            return([false,"信息不存在,请先调用creat接口"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            lst.seq       = lst.seq+1n;
            {
                Object.assign(lst,D);
                //----------------
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst;
                let r       = await this.insert_one(paramd);
                r = r[0];
                Object.assign(fst,D);
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                //----------------------------------------------------------------------
                this.lock.release(sheet_id);
                return([true,r0])
            }
        }
    }
    //// 强制删除
    async del(sheet_id) {
        await this.lock.acquire(sheet_id);
        let paramd                 = nofix_eng.DB.DELETE_PARAM.delete_with_match();
        paramd.tbl  = this.tbl;
        paramd.cond = `sheet_id==='${sheet_id}'`;
        let r       = await this.delete_with_match(paramd);
        this.lock.release(sheet_id);
        return([true,r])
    }
    ////数量
    async count(cudata={}) {
            let paramd                 = nofix_eng.DB.COUNT_PARAM.count_of_used();
            paramd.tbl                 = this.tbl;
            paramd.cond                = `seq===0`
            Object.assign(paramd,cudata); 
            let r       = await this.count_of_used(paramd);
            return(r)
    }
    ////获取
    async select(cudata={}) {
            let paramd                 = nofix_eng.DB.SELECT_PARAM.select_with_match();
            paramd.tbl  = this.tbl;
            paramd.cond                = `seq===0`;
            Object.assign(paramd,cudata);
            let r       = await this.select_with_match(paramd);
            return(r)    
    }
    ////導出
    async expt(cudata={}) {
           let paramd                 = nofix_eng.DB.SELECT_PARAM.select_with_match();
           paramd.tbl  = this.tbl;
           Object.assign(paramd,cudata);    
           let ag = this.gen_select_all_with_match(paramd);
           let rslt = []
           for await(let rows of ag) {
               rslt = rslt.concat(rows)
           } 
           rslt = _grpby(rslt); 
           return(rslt) 
    }
    ////统计:
    async stat(cudata={}) {
        let {y,months,mrange} = cudata;
        if(months === undefined && mrange=== undefined) {
            months = [1,2,3,4,5,6,7,8,9,10,11,12];
        } else if(mrange !== undefined) {
           let [sm,em] = mrange;
           months = [];
           for(let i=sm;i<=em;i=i+1) {
               months.push(i)
           } 
        } else {
        }
        /*
        for(let m of months) {
           month_cond.push(`m=${m}`)
        }
        */
        let sqld   = {} 
        for(let m of months) {
            let d = {
                "参与答题次数"  :0,
                "参与答题人数"  :0,
                "答对总数"      :0,
                "答错总数"      :0,
                "参与抽奖次数"  :0,
                "参与抽奖人数"  :0,
                "已发放红包金额":0,
                "已领取红包金额":0
            };
            ////
           ////
            let answer_times = await this.exec_raw_sql(
                 `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='回答问题');`
            );
            answer_times = answer_times[0][0]?.count??0;
            d["参与答题次数"] = Number(answer_times);   
            ////c6 是openid 
            let answer_peoples = await this.exec_raw_sql(
                 `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='回答问题') GROUP BY c6;`
            );
            answer_peoples = answer_peoples[0][0]?.count??0;
            d["参与答题人数"] = Number(answer_peoples);            
            ////c16 是 can_draw_lottery
            let oks = await this.exec_raw_sql(
                 `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='回答问题') AND (c17=TRUE);`
            );
            oks  = oks[0][0]?.count??0;
            d["答对总数"]  = Number(oks); 
            ////c16 是 c16 是 can_draw_lottery
            let nos = await this.exec_raw_sql(                 
                `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='回答问题') AND (c17=FALSE);`
            );
            nos  = nos[0][0]?.count??0;
            d["答错总数"]  = Number(nos); 
            ////
            ////
            let lottery_times = await this.exec_raw_sql(
                 `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='用户抽奖');`
            );
            lottery_times = lottery_times[0][0]?.count??0;
            d["参与抽奖次数"] = Number(lottery_times);
            ////c6 是openid 
            let lottery_peoples = await this.exec_raw_sql(
                 `SELECT count(1) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='用户抽奖') GROUP BY c6;`
            );
            lottery_peoples = lottery_peoples[0][0]?.count??0;
            d["参与抽奖人数"] = Number(lottery_peoples);
            ////
            ////c17 是 is_drawed
            let hb_gived_total = await this.exec_raw_sql(
                 `SELECT sum(c25) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='用户抽奖') AND (c18 = TRUE);`
            );
            hb_gived_total  = hb_gived_total[0][0]?.sum??0;
            d["已发放红包金额"]  = Number(hb_gived_total);  
            ////
            let hb_taked_total = await this.exec_raw_sql(
                 `SELECT sum(c25) FROM query WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='用户提现') AND (c21 = TRUE);`
            );
            hb_taked_total  = hb_taked_total[0][0]?.sum??0;
            d["已领取红包金额"]  = Number(hb_taked_total)
            ////;
            sqld[m] = d
        }
        return(sqld)
    }
}

DataBase.PARAMS = {
    select:{
        cond:'jscode-for-match',
        srch_ptrn:'full-text-search-string',
        oper:'AND',
        offset:0,
        limit:1024,
        order_by: [],
        slct_cols: null
    },
    count:{
        cond:'jscode-for-match',
        srch_ptrn:'full-text-search-string',
        oper:'AND'
    },
    del:'sheet_id',
    take_hb: {
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        take_hb:100
    },
    draw_lottery:{
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        draw_lottery:100
    },
    answer:{
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        answer:100
    },
    get_details:'sheet_id',
    update_extra: {
        sheet_id:'',  
        oper:'',      //操作员,后端自动填写
        extra:{},
    },
    creat: {
        oper:'',  //操作员,后端自动填写
        ...{},    //前端数据
    },
}


const DFLT_ROUTE_PREFIX = "/rmt_wxhb_query_paper";

const creat_routes = (prefix=DFLT_ROUTE_PREFIX)=> {
    let d = {}
    d[`${prefix}/init_qp`]           = 'init_qp',       //僅僅爲了路由,此函數在db端沒有任何功能
    d[`${prefix}/select`]            = 'select';
    d[`${prefix}/count`]             = 'count'; 
    d[`${prefix}/del`]               = 'del';           //sheet_id

    d[`${prefix}/creat`]             = 'creat';        //用戶創建
    d[`${prefix}/answer`]            = 'answer';        //用戶答題 openid
    d[`${prefix}/draw_lottery`]      = 'draw_lottery';  //用戶抽奖 openid

    d[`${prefix}/get_details`]       = 'get_details';  //sheet_id
    d[`${prefix}/update_extra`]      = 'update_extra'; //{sheet_id,oper,extra}

    d[`${prefix}/expt`]              = 'expt';
    d[`${prefix}/stat`]              = 'stat';
    return(d)
}

const DFLT_TBL_NAME = 'query';

const DFLT_DB_NAME  = 'rmt_wxhb_query_paper';

const init = async (dbname=DFLT_DB_NAME,tbl=DFLT_TBL_NAME,cfgdb,retry_redis,wx,oss)=> {
    let db = new DataBase(dbname,tbl,cfgdb,retry_redis,wx,oss);
    await db.conn();
    await db.init_qp();
    return(db)
}


module.exports = {
   DataBase,
   DFLT_ROUTE_PREFIX,creat_routes, 
   DFLT_TBL_NAME, 
   init 
}
